<template>
  <el-col :span="16" :offset="6">
    <el-form label-width="100px" ref="formRef" :model="form">
      <el-form-item
        label="审批建议"
        prop="reason"
        style="margin-bottom: 20px"
        :rules="{
          required: true,
          message: '请选择',
          trigger: 'change'
        }"
      >
        <el-input
          type="textarea"
          v-model="form.reason"
          placeholder="请输入审批建议"
        />
      </el-form-item>
    </el-form>
    <div style="margin-left: 10%; margin-bottom: 20px; font-size: 14px">
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        v-if="
          taskDefinitionKey != 'storemanApprove' ||
          (taskDefinitionKey == 'storemanApprove' &&
            outInData.verifyStatus == 2)
        "
        @click="handleAudit(1)"
        >通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="success"
        size="mini"
        :loading="isSaveLoading"
        @click="storemanApprove"
        v-if="
          ['storemanApprove'].includes(taskDefinitionKey) &&
          activeComp == 'outBound' &&
          [0, 3].includes(outInData.verifyStatus)
        "
        >申请出库
      </el-button>
      <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="
          ['deptLeaderApprove', 'storemanApprove'].includes(
            taskDefinitionKey
          ) && outInData.verifyStatus != 1
        "
        >驳回
      </el-button>



      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleBackList"
        >退回
      </el-button> -->
      <!-- <el-button
        icon="el-icon-circle-close"
        type="danger"
        size="mini"
        @click="handleAudit(0)"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        >不通过
      </el-button>
      <el-button
        icon="el-icon-edit-outline"
        type="primary"
        size="mini"
        v-if="taskDefinitionKey != 'productionSupervisorApprove1'"
        @click="handleUpdateAssignee"
        >转办
      </el-button> -->
    </div>
  </el-col>
</template>

<script>
  import {
    UpdateSendInformation,
    getSendSaleOrderrecordDetail,
    getWarehouseListByIds,
    saleSendProcessCancel,
  } from '@/api/bpm/components/saleManage/saleorder';
  import { approveTaskWithVariables } from '@/api/bpm/task';
  import { getOutInBySourceBizNo } from '@/api/classifyManage';
  import outin from '@/api/warehouseManagement/outin';
  import { data } from 'ele-admin/lib/ele-pro-table';

  // 流程实例的详情页，可用于审批
  export default {
    name: '',
    components: {
      //   Parser
    },
    props: {
      businessId: {
        default: ''
      },
      taskId: {
        default: ''
      },
      id: {
        default: ''
      },
      taskDefinitionKey: {
        default: ''
      }
    },
    data() {
      return {
        isSaveLoading: false,
        form: {
          technicianId: '',
          reason: ''
        },
        outInData: { verifyStatus: '' },
        activeComp: ''
      };
    },
    async created() {
      if (this.taskDefinitionKey == 'storemanApprove') {
        let data = await getSendSaleOrderrecordDetail(this.businessId);
        try {
          console.log(1111, '1111111111');
          this.outInData = await getOutInBySourceBizNo(data.docNo);
          console.log(this.outInData, '============');
        } catch (error) {
          console.log(22222222, '22222222222');
          this.outInData.verifyStatus = 0;
        }
      }
      console.log('taskDefinitionKey', this.taskDefinitionKey);
      console.log('outInData', this.outInData);
    },
    methods: {
      async storemanApprove() {
        let res = await this.getTableValue();
        let storageData = res.returnStorageData;
        console.log(storageData);
        // 出库来源storageSource 0-正常  1-外部(外部跳过内部审核流程)
        storageData.storageSource = 1;
        try {
          this.isSaveLoading = true;
          await outin.saveNew(storageData);
          approveTaskWithVariables({
            id: this.taskId,
            reason: this.form.reason,
            variables: {
              pass: true
            }
          }).then((res) => {
            if (res.code != '-1') {
              this.$emit('handleAudit', {
                status: 1,
                title: '出库'
              });
            }
            this.isSaveLoading = false;
          });
        } catch (error) {
          this.isSaveLoading = false;
          console.error('保存失败：', error);
        }
      },
      activeCompChange(activeComp) {
        this.activeComp = activeComp;
      },
      /** 处理转办审批人 */
      handleUpdateAssignee() {
        this.$emit('handleUpdateAssignee');
      },
      /** 退回 */
      handleBackList() {
        this.$emit('handleBackList');
      },

      async handleAudit(status) {
        let storemanIds = '';
        //发起人补充
        if (
          this.taskDefinitionKey === 'starter' ||
          this.taskDefinitionKey === 'salesmanUploadReceipt'
        ) {
          let arr = await this.getTableValue();
          console.log('arr--------', arr);
          if (!arr) {
            return;
          }
          if (
            this.taskDefinitionKey === 'salesmanUploadReceipt' &&
            arr.replied === 0
          ) {
            this.$message.error('回执附件不能为空');
            return;
          }
          // console.log(arr)
          // return
          let data = await UpdateSendInformation(arr);
          if (data.code != '0') {
            return;
          }
        }

        if (this.taskDefinitionKey === 'deptLeaderApprove') {
          let arr = await this.getTableValue();
          let ids = arr.form.productList.map((item) => item.warehouseId);
          let data = await getWarehouseListByIds(ids || []);
          storemanIds = data.map((item) => item.ownerId);
        }
        this._approveTaskWithVariables(
          status,
          storemanIds.length > 0
            ? Array.from(new Set(storemanIds)).toString()
            : ''
        );
      },
      async _approveTaskWithVariables(status, storemanIds) {
        let variables = {
          pass: !!status
        };
        if (storemanIds) {
          variables['storemanIds'] = storemanIds;
        }
        approveTaskWithVariables({
          id: this.taskId,
          reason: this.form.reason,
          variables
        }).then((res) => {
          if (res.data.code != '-1') {
            this.$emit('handleAudit', {
              status,
              title: status === 0 ? '驳回' : ''
            });
          }
        });
      },
      getTableValue() {
        return new Promise((resolve, reject) => {
          this.$emit('getTableValue', async (data) => {
            resolve(await data);
          });
        });
      },

      //更多
      handleCommand(command) {
        if (command === 'cancel') {
          this.$confirm("是否确认作废？", {
            type: 'warning',
            cancelButtonText: '取消',
            confirmButtonText: '确定'
          }).then(() => {
            saleSendProcessCancel({
              id: this.taskId,
              reason: this.form.reason,
              businessId: this.businessId,
            }).then(() => {
              this.$emit('handleClose');
            }).catch(() => {
              this.$message.error("流程作废失败");
            });
          }).catch(() => {});
        }
      },

    }
  };
</script>

<style lang="scss"></style>
